<?php
if (!class_exists('UpiCRMFB_get_leads')) {

    class UpiCRMFB_get_leads {

        var $fb_api_version;
        var $fb_scope;
        var $fb_app_id;
        var $fb_app_secret;
        var $fb_page_id;
        var $access_token;

        function __construct() {
            $UpiCRMFB_conf = new UpiCRMFB_conf();
            $conf_OBJ = $UpiCRMFB_conf->get();
            $conf = $conf_OBJ[0];
            
            $this->fb_api_version = $conf->fb_api_version;
            $this->fb_scope = $conf->fb_scope;
            $this->fb_app_id = $conf->fb_app_id;
            $this->fb_app_secret = $conf->fb_app_secret;
            $this->fb_page_id = $conf->fb_page_id;
            $this->fb_access_token = $conf->fb_access_token;
            $this->fb_page_access_token = $conf->fb_page_access_token;
        }
        
        function get_all_forms() {
            $fb = new Facebook\Facebook([
                'app_id' => $this->fb_app_id,
                'app_secret' => $this->fb_app_secret,
                'default_graph_version' => $this->fb_api_version,
            ]);
            
            try {
                // Returns a `Facebook\FacebookResponse` object
                $response = $fb->get(
                        "/$this->fb_page_id/leadgen_forms", $this->fb_page_access_token
                );
            } catch (Facebook\Exceptions\FacebookResponseException $e) {
                echo 'Graph returned an error: ' . $e->getMessage();
                exit;
            } catch (Facebook\Exceptions\FacebookSDKException $e) {
                echo 'Facebook SDK returned an error: ' . $e->getMessage();
                exit;
            }
                $response = $fb->get(
                        "/$this->fb_page_id/leadgen_forms", $this->fb_page_access_token
                );
            return $response->getGraphEdge()->asArray();
        }
        
        function get_access_token() {
            $fb = new Facebook\Facebook([
                'app_id' => $this->fb_app_id,
                'app_secret' => $this->fb_app_secret,
                'default_graph_version' => $this->fb_api_version,
            ]);
            
            $client = $fb->getOAuth2Client();
            $helper = $fb->getJavaScriptHelper();

            try
            {
                $shortLivedTokenObject = $helper->getAccessToken(); /* this token expires */
                error_log("\$shortLivedTokenObject: {$shortLivedTokenObject}");
                $accessTokenObject = $client->getLongLivedAccessToken($shortLivedTokenObject); /* this is a never-expiring token - it should NEVER be exposed on client side */

                $accessToken = $accessTokenObject->getValue();
                error_log("\$accessToken: {$accessToken}");

            } catch (FacebookResponseException $e)
            {
                // When Graph returns an error
                $error = 'Graph returned an error: ' . $e->getMessage();
            } catch (FacebookSDKException $e)
            {
                // When validation fails or other local issues
                $error = 'Facebook SDK returned an error: ' . $e->getMessage();
            }
            
            return $accessToken;
        }
        
        function get_fb_id() {
            $fb = new Facebook\Facebook([
                'app_id' => $this->fb_app_id,
                'app_secret' => $this->fb_app_secret,
                'default_graph_version' => $this->fb_api_version,
            ]);

            $subscribedApps = [];
            $error = false;
            try {
                $request = $fb->request('GET', "/me/accounts", [], $this->fb_access_token);

                $response = $fb->getClient()->sendRequest($request);
                $pages = $response->getGraphEdge();
                $all_pages = $pages->asArray();

                
                while (1) {
                    $pages = $fb->next($pages);
                    if (is_null($pages)) {
                        break;
                    }

                    $all_pages = array_merge($all_pages, $pages->asArray());
                }
                return $all_pages;
                /* get apps subscribed to this page */
                /*$request = $fb->request('GET', "/{$fb_page_id}/subscribed_apps", [], $page_access_token);
                $response = $fb->getClient()->sendRequest($request);
                $body = $response->getDecodedBody();
                $subscribedApps = $body['data'];*/
            } catch (FacebookResponseException $e) {
                // When Graph returns an error
                $error = 'Graph returned an error: ' . $e->getMessage();
            } catch (FacebookSDKException $e) {
                // When validation fails or other local issues
                $error = 'Facebook SDK returned an error: ' . $e->getMessage();
            }

            return $error;
        }
        
        function get_by_form_id($form_id, $access_token) {
            $leads_OBJ = file_get_contents("https://graph.facebook.com/v3.3/{$form_id}/leads?access_token={$access_token}");
            return json_decode($leads_OBJ, true);
        }
        
        function get_field_by_form_id($form_id, $access_token) {
            $leads_OBJ = file_get_contents("https://graph.facebook.com/v3.3/{$form_id}/leads?access_token={$access_token}");
            $leads_arr = json_decode($leads_OBJ, true);
            $arr = [];
            foreach ($leads_arr['data'][0]['field_data'] as $lead) {
                $arr[] = $lead['name'];
            }
            return $arr;
        }
        
        function save_lead() {
            global $SourceTypeID;
            $addedcount = 0;
            $UpiCRMLeads = new UpiCRMLeads();
            $UpiCRMFB_form = new UpiCRMFB_form();
            
            $forms_arr = $this->get_all_forms();
            foreach ($forms_arr as $fb_form) {
                $form = $UpiCRMFB_form->get_by_fb_id($fb_form['id']);
                if (strtolower($fb_form['status']) == "active" && $form->fb_form_id && $form->fb_form_status == 1) {
                    $leads_arr = $this->get_by_form_id($form->fb_id,$this->fb_page_access_token);
                    //print_r($leads_arr);
                    $count = $form->fb_form_start_line;
                    $count_leads_arr = count($leads_arr['data']);
                    for ($i=0; $i<= $count_leads_arr-1; $i++) {
                        if ($i >= $count) {
                            $content_arr = [];
                            foreach ($leads_arr['data'][$i]['field_data'] as $lead) {
                                //print_r($lead);
                                $content_arr[$lead['name']] = $lead['values'][0];
                            }
                            //print_r($content_arr);
                            $UpiCRMLeads->add($content_arr, $SourceTypeID['fb_lead'], $form->fb_form_id);
                            $addedcount++;
                        };
                    }
                    $UpiCRMFB_form->update(['fb_form_start_line' => $count_leads_arr],$form->fb_form_id);
                }
            }
            upicrmfb_success_count_notice($addedcount);
        }
        
        function save_lead_by_form($id) {
            global $SourceTypeID;
            $addedcount = 0;
            $UpiCRMLeads = new UpiCRMLeads();
            $UpiCRMFB_form = new UpiCRMFB_form();
            $form = $UpiCRMFB_form->get_by_id($id);
            if ($form->fb_form_id && $form->fb_form_status == 1) {
                $leads_arr = $this->get_by_form_id($form->fb_id,$this->fb_page_access_token);
                $count = $form->fb_form_start_line;
                $count_leads_arr = count($leads_arr['data']);
                for ($i=0; $i<= $count_leads_arr-1; $i++) {
                    if ($i >= $count) {
                        $content_arr = [];
                        foreach ($leads_arr['data'][$i]['field_data'] as $lead) {
                            $content_arr[$lead['name']] = $lead['values'][0];
                        }
                        $UpiCRMLeads->add($content_arr, $SourceTypeID['fb_lead'], $form->fb_form_id);
                        $addedcount++;
                    };
                    
                }
                $UpiCRMFB_form->update(['fb_form_start_line' => $count_leads_arr],$form->fb_form_id);
            }
            upicrmfb_success_count_notice($addedcount);
        }
        
        function get_form_name($arr) {
            global $SourceTypeID;
            if ($arr['source_type'] == $SourceTypeID['fb_lead']) {
                //TODO: if you need you can optimize this with array instead of live query
               $UpiCRMFB_form = new UpiCRMFB_form();
               $row = $UpiCRMFB_form->get_by_id($arr['source_id']);
               if (isset($row)) {
                   return $row->fb_form_title;
               }
            }
        }

    }
    
}
add_filter('upicrm_get_name_'.$SourceTypeID['fb_lead'],array('UpiCRMFB_get_leads','get_form_name'));

?>