<div id="upicrmfb-help">
<h1>Facebook integration guide – import leads from Facebook into UpiCRM</h1>
<br>
<h2>Introduction:</h2>
<p>UpiCRM can import leads from Facebook into your lead management solution.  In order to import leads from Facebook, you will need to create an "App" on Facebook, and provide the Facebook App&apos;s ID and secret App ID.</p>
<p>After you have connected with the App&apos;s ID&apos;s , you can now log in to you Facebook account, connect to the leads ads forms, and map the fields from your Facebook leads forms with the UpiCRM lead management solution.</p>
<p>After the forms are configured, UpiCRM will import the new leads every 1 hour (by default), and you can now manage the leads on your WordPress server with UpiCRM.</p>
<p>This setup should take between 10 to 15 minutes to a "non-programmer" user.</p>
<br>
<h2>Step by step instructions:</h2>
<ol class="help-steps">
    <li>Preliminary requisite: make sure you have the latest version of UpiCRM installed from WordPress.org (<a href="https://wordpress.org/plugins/upi-crm-universal-crm-solution/" target="_blank">https://wordpress.org/plugins/upi-crm-universal-crm-solution/</a>) and that you have installed the latest version of UpiCRM Facebook leads extension – link: <a href="https://www.upicrm.com" target="_blank">https://www.upicrm.com</a></li>
    <li>Go to <a href="https://developers.facebook.com/apps/" target="_blank">https://developers.facebook.com/apps/</a> and choose "Add new App"
    <br>
    <img src="<?php echo plugins_url('helpimages/image1.png', __FILE__); ?>" style="width: 460px; height: auto;">
    </li>
    <li>Give your app a name and provide an email address, then click on "Create App ID":
    <br>
    <img src="<?php echo plugins_url('helpimages/image2.png', __FILE__); ?>" style="width: 520px; height: auto;">
    </li>
    <li>Now, on your WordPress dashboard, enter the option of UpiCRM for Facebook integration, and click the setup button:
    <br>
    <img src="<?php echo plugins_url('helpimages/image3.png', __FILE__); ?>" style="width: 466px; height: auto;">
    </li>
    <li>You will now need to provide your App ID and secret app key:
    <br>
    <img src="<?php echo plugins_url('helpimages/image4.png', __FILE__); ?>" style="width: 436px; height: auto;">
    </li>
    <li>Obtain the ID and secret key from the Facebook developers page on <a href="https://developers.facebook.com/apps/" target="_blank">https://developers.facebook.com/apps/</a>, choose your APP&apos;s "Basic" settings, and copy the fields into UpiCRM.
    <br>
    <img src="<?php echo plugins_url('helpimages/image5.png', __FILE__); ?>" style="width: 690px; height: auto;">
    </li>
    <li>Before you can connect with Facebook , your app needs to have two more capabilities, called "Products" on the Facebook app screen:
    <br>
    <img src="<?php echo plugins_url('helpimages/image6.png', __FILE__); ?>" style="width: 190px; height: auto;">
    <br>
    You need to add "Marketing Api"  and "Facebook Login"
    <br>
    <img src="<?php echo plugins_url('helpimages/image7.png', __FILE__); ?>" style="width: 235px; height: auto;">
    <br>
    <img src="<?php echo plugins_url('helpimages/image8.png', __FILE__); ?>" style="width: 235px; height: auto;">
    <br>
    FaceBook Login – Choose "WWW" / Web, and then the Facebook login api will require you to provide your UpiCRM installation domain name (the address from which you&apos;ll be accessing the Facebook Api… meaning the domain on which UpiCRM is installed:
    <br>
    <img src="<?php echo plugins_url('helpimages/image9.png', __FILE__); ?>" style="width: 620px; height: auto;">
    </li>
    <li>You can now login to Facebook and connect your app to your page and leads forms:
    <br>
    <img src="<?php echo plugins_url('helpimages/image10.png', __FILE__); ?>" style="width: 290px; height: auto;">
    </li>
    <li>When you complete the "connect with Facebook" UpiCRM is now ready to import your leads:
    <br>
    <img src="<?php echo plugins_url('helpimages/image11.png', __FILE__); ?>" style="width: 420px; height: auto;">
    </li>
    <li>Go to the "Forms" tab:
    <br>
    <img src="<?php echo plugins_url('helpimages/image12.png', __FILE__); ?>" style="width: 740px; height: auto;">
    <br>
    You can "Enable" any form from Facebook , map the form&apos;s fields, and retrieve the information from Facebook into UpiCRM.
    </li>
    <li>Click "Enable" on your chosen form, then provide a name for your form and click "Save":
    <br>
    <img src="<?php echo plugins_url('helpimages/image13.png', __FILE__); ?>" style="width: 400px; height: auto;">
    </li>
    <li>You will now be able to map the fields from the Facebook leads forms with UpiCRM datatypes:
    <br>
    <img src="<?php echo plugins_url('helpimages/image14.png', __FILE__); ?>" style="width: 390px; height: auto;">
    </li>
    <li>Click on "Run Now" and you&apos;ll see an indication that the leads are imported into UpiCRM:
    <br>
    <img src="<?php echo plugins_url('helpimages/image15.png', __FILE__); ?>" style="width: 680px; height: auto;">
    </li>
    <li>Go to the "lead management" screen of UpiCRM , you&apos;ll now see the new lead from Facebook on your lead management table:
    <br>
    <img src="<?php echo plugins_url('helpimages/image16.png', __FILE__); ?>" style="width: 670px; height: auto;">
    </li>
</ol>
<p>That&apos;s it… all your Facebook leads will now be imported as they are generated on your Facebook campaigns, and you&apos;ll be able to manage, distribute, assign, and export all your leads from UpiCRM. </p>
</div>
<style>
    #upicrmfb-help {
        margin-top: 50px;
    }
    #upicrmfb-help p {
        font-size: 16px;
        line-height: 26px;
    }
    #upicrmfb-help .help-steps li {
        font-size: 15px;
        line-height: 22px;
        margin: 30px 0;
        font-weight: 600;
    }
    #upicrmfb-help .help-steps li img {
        margin: 15px 0;
    }
    /* #upicrmfb-help p, #upicrmfb-help * {
    }
    
    #upicrmfb-help .help-steps li {
        margin-top: 35px;
        font-weight: bold;
    }
    #upicrmfb-help .help-steps li img {
        transform: scale(0.4);
        margin-top: 20px;
    } */
</style>