<?php
$field_arr = $UpiCRMFB_get_leads->get_field_by_form_id($fb_id,$UpiCRMFB_get_leads->fb_page_access_token);
if (empty($field_arr) && isset($_GET['testlead'])) {
    $mffb = new Facebook\Facebook([
                'app_id' => $UpiCRMFB_get_leads->fb_app_id,
                'app_secret' => $UpiCRMFB_get_leads->fb_app_secret,
                'default_graph_version' => $UpiCRMFB_get_leads->fb_api_version,
                'default_access_token' => $UpiCRMFB_get_leads->fb_page_access_token,
            ]);
    try {
        $testleadgen = $mffb->post('/'.$form->fb_id.'/test_leads');
        if ($testleadgen) {
            $field_arr = $UpiCRMFB_get_leads->get_field_by_form_id($fb_id,$UpiCRMFB_get_leads->fb_page_access_token);
            echo '<p><strong style="color: limegreen; font-size: 15px;">Test Lead Created!</strong></p>';
            /*$testingleads = $mffb->get('/'.$form->fb_id.'/test_leads');
            $theleads = $testingleads->getGraphEdge()->asArray();
            if (!empty($theleads)) {
                $theleadnow = $theleads[0]['id'];
                $mffb->delete('/'.$theleadnow);
            }*/
        }
    } catch (Facebook\Exceptions\FacebookResponseException $e) {
        echo 'Graph returned an error: ' . $e->getMessage();
        exit;
    } catch (Facebook\Exceptions\FacebookSDKException $e) {
        echo 'Facebook SDK returned an error: ' . $e->getMessage();
        exit;
    }
}
?>
<br />
<form method="post" class="upi-field-mapping-form">
    <input type="hidden" value="save">
    <?php
    $title = __('Map fields from:', 'upicrm_fb');

    $table_arr[] = [
        __('Facebook Field', 'upicrm_fb'),
        __('UPiCRM Field', 'upicrm'),
    ];
    $UpiCRMFields = new UpiCRMFields();

    if (!empty($field_arr)) {
        foreach ($field_arr as $val) {
            $select = '<select data-callback="save_field" data-name="'. $val.'" data-fm_id="">
                        <option value="0"></option>';
            foreach ($UpiCRMFields->get() as $field) {
                $select .= '<option value="' . $field->field_id . '">' . $field->field_name . '</option>'; //selected( $field->field_id, $fm_obj->field_id );
            }
            $select .= '</select>';
            
            $table_arr[] = [
                $val,
                $select
            ];
        }
    } else {
        echo '<br /><p style="font-size: 15px;">There must be at least one lead for field mapping.<br /><strong><a href="admin.php?page=upicrm_fb_map_fields&id='.$form->fb_id.'&testlead=1">Click Here to Create Test Lead</a></strong></p>';
    }
    $UpiCRMUIBuilder = new UpiCRMUIBuilder();
    $UpiCRMUIBuilder->show_table('map_fields_table', $title, $table_arr, 'col-xs-12 col-sm-12 col-md-5 col-lg-5');
    ?>
</form>
<a href="admin.php?page=upicrm_fb" class="button button-primary">Go Back</a><a href="#" id="reset_field_mapping" class="button button-red-action">Reset Field Mapping</a>

<script type="text/javascript">
    jQuery(document).ready(function() {
        jQuery(document).on('click', '#reset_field_mapping', function() {
            var resetconfirm = confirm('Are you sure to reset field mapping?');
            if (resetconfirm == true) {
                var data = {
                    'action': 'reset_field_mapping_fb',
                    'source_id': <?php echo $form->fb_form_id ?>,
                };
                jQuery.post(ajaxurl, data, function (response) {
                    if (response != 0) {
                        jQuery('.upi-field-mapping-form select').each(function() {
                            jQuery(this).val(0);
                        });
                        jQuery.bigBox({
                            title: "Reset succesfully!",
                            content: "<h4 style='font-size: 1.3em;'>Fields map has been reset.</h4>",
                            color: "#739E73",
                            timeout: 5000,
                            icon: "fa fa-check-square-o",
                            number: ""
                        }, function () {
                            closedthis();
                        });
                    } else {
                        jQuery.bigBox({
                            title: "Reset failed!",
                            content: "Field mapping reset failed.",
                            color: "#C46A69",
                            icon: "fa fa-warning shake animated",
                            number: "",
                            timeout: 3000
                        });
                    }
                });
            }
        });
    });
    jQuery(document).ready(function ($) {
        <?php
        $UpiCRMFieldsMapping = new UpiCRMFieldsMapping();
        $fields_mapping_obj = $UpiCRMFieldsMapping->get_all_by($form->fb_form_id, $SourceTypeID['fb_lead']);
        if (isset($fields_mapping_obj) && $fields_mapping_obj) { 
            foreach($fields_mapping_obj as $obj) { ?>
                $("select[data-callback='save_field'][data-name='<?= $obj->fm_name; ?>'] option[value='<?= $obj->field_id?>']").attr('selected', 'selected');
                $("select[data-callback='save_field'][data-name='<?= $obj->fm_name; ?>']").attr('data-fm_id', '<?= $obj->fm_id?>');
            <?php }
        }
        ?>
        
        $("select[data-callback='save_field']").change(function () {
            var _this = $(this);
            if (_this.val() != 0) {
                var data = {
                    'action': 'save_field_mapping_fb',
                    'fm_name': $(this).attr("data-name"),
                    'source_id': <?php echo $form->fb_form_id ?>,
                    'field_id': $(this).val(),
                    'fm_id': $(this).attr("data-fm_id"),

                };
        console.log(data);
                $.post(ajaxurl, data, function (response) {
                    if (response != 0) {
                        _this.attr("data-fm_id", response);
                        $.bigBox({
                            title: "Field has been mapped succesfully!",
                            content: "Your new mapping pair is:<br/><h4 style='font-size: 1.3em;'>" + _this.attr("data-name") + " >> " + _this[0].options[_this[0].selectedIndex].text + "</h4>",
                            color: "#739E73",
                            timeout: 5000,
                            icon: "fa fa-check-square-o",
                            number: ""
                        }, function () {
                            closedthis();
                        });
                    } else {
                        _this.val(0);
                        $.bigBox({
                            title: "Field mapping attempt failed!",
                            content: "Please, select another UPiCRM field.",
                            color: "#C46A69",
                            icon: "fa fa-warning shake animated",
                            number: "",
                            timeout: 4500
                        });
                    }
                });
            }
        });

    });
</script>